import express from "express";
import fs from "fs";
import os from "os";
import path from "path";
import _ from "lodash";
import player from "node-wav-player";

let playing = false;

const tempFolder = fs.mkdtempSync(path.join(path.join(os.tmpdir(), 'speaker-')));

export default async function (req:express.Request, res:express.Response) {
  try {
    if (playing) {
      throw new Error("playing");
    }

    playing = true;

    const { filename, data } = req.body;

    const audioPath = path.join(tempFolder, filename);
    fs.writeFileSync(audioPath, data, "base64");

    console.log("Playing", audioPath);

    res.json({ isSuccess: true })

    try {
      await player.play({
        path: audioPath,
        sync: true
      });
  
      fs.unlinkSync(audioPath);  
    } catch (error) {
      console.error(error);
    }

    playing = false;
  } catch (error) {
    console.error(error);
    return res.json({ isSuccess: false, reason: error.message });
  }
}